using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Net;
using System.IO;
using System.Threading;
using System.Net.Sockets;
using System.Windows.Forms;

namespace HPi_DM
{
    public partial class DMClient : Form
    {
        private EY_ClientSocket eyClient = null;
        private string strLog = "";
        private string strErr = "";
        private string strHostName="";
        public string strCurUserID = "";
        private string strMyID = "";
        public string strVersion = "0.01";
        public Hashtable ClientList = new Hashtable();
        private bool bClosing = false;

        public DMClient()
        {
            InitializeComponent();
            eyClient = new EY_ClientSocket(this);
        }

        private void DMClient_Load(object sender, EventArgs e)
        {
            this.Text = "() - Version " + strVersion;
            InitSetting();
            Server_Connect(strMyID, "");
            lblUserState.Text = "";
            Update_Client();
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            Send_Msg(txtWrite.Text);
            txtWrite.Text = "";
            txtWrite.Focus();

            if (lstIP.Items.Count < 1) return;
        }

        private void btnEnd_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        public bool Server_Connect(string strPID, string strPPass)
        {
            if (eyClient.bConnectServer)
            {
                strLog = string.Format(" DM Դϴ.!!");
                Add_Log(strLog);
                return false;
            }

            if (eyClient.Connect_Server(strPID))
            {
                strLog = string.Format("MTS   !!");
                Add_Log(strLog);

                strCurUserID = strPID;
                return true;
            }
            else
            {
                strErr = string.Format("{0}", eyClient.Get_LastError());
                MessageBox.Show(strErr);
                Application.Exit();
                return false;
            }
        }

        public void Server_Disconnect()
        {
            Application.Exit();
        }

        public void Add_Log(string strPLog)
        {
            Console.WriteLine(strPLog);
        }

        public void ReceiveMsg_FromSocket(string strPReceive)
        {
            if (!eyClient.bConnectServer)
            {
                strErr = string.Format("   ʾҽϴ.");
                Add_Log(strErr);
                return;
            }
            strLog = string.Format("{0}", strPReceive);


            if (bClosing) return;

            if (strPReceive == "ER0001")
            {
                bClosing = true;
                MessageBox.Show("  Դϴ. ٸ ̵ ּ!!");

                Application.Exit();
            }
            else
            {
                Show_Chat("", strPReceive);
            }
        }

        private void Update_Client()
        {
            IPAddress ipaddr = Dns.GetHostByName(strHostName).AddressList[0];
            lblUserIP.Text = ipaddr.ToString();
            lblUserPort.Text = "3000"; 
            lblSoftVersion.Text = strVersion;
        }


        private void InitSetting()
        {
            ClientSetting frm_ServerSetting = new ClientSetting();
            frm_ServerSetting.StartPosition = FormStartPosition.CenterParent;

            frm_ServerSetting.strServerIP = eyClient.Get_MyIP();
            frm_ServerSetting.intServerPort = eyClient.Get_ServerPort();

            if (DialogResult.OK == frm_ServerSetting.ShowDialog())
            {
                eyClient.Set_ServerIP(frm_ServerSetting.strServerIP);
                eyClient.Set_ServerPort(frm_ServerSetting.intServerPort);

                strMyID = frm_ServerSetting.strMyID;
            }
            else
            {
                Application.Exit();
            }
        }

        private void ToolStripMenuItem_Click_1(object sender, EventArgs e)
        {
            Application.ExitThread();
        }

        public void Show_Chat(string strPUserID, string strPMsg)
        {
            this.Invoke(new MethodInvoker(delegate()
                 {
                     txtView.AppendText(strPMsg + "\r\n");
                     txtView.ScrollToCaret();
                 }
                 )
            );
        }

        public void Send_Msg(string strPMsg)
        {
            if (!eyClient.bConnectServer)
            {
                strErr = string.Format("   ʾҽϴ.");
                Add_Log(strErr);
                return;
            }

            if (strPMsg == "") return;
            eyClient.SendMsg(strPMsg);
        }

        private void txtSendMsg_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (int)Keys.Enter)
            {
                btnSend_Click(null, null);
            }
        }

        private void txtWrite_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (int)Keys.Enter)
            {
                btnSend_Click(null, null);
            }
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Made by Essetel Co.,Ltd");
        }

        public void Add_User(string strTUserID)
        {
            this.Invoke(new MethodInvoker(delegate()
                 {
                     string[] strData = new string[2];
                     int intTClientCount = lstIP.Items.Count + 1;
                     strData[0] = intTClientCount.ToString();
                     strData[1] = strTUserID;
                     lstIP.Items.Add(new ListViewItem(strData));
                     Update_Client();
                 }
                 )
            );
        }

        public void Remove_User(string strTUserID)
        {
            if (ClientList.ContainsKey(strTUserID))
            {
                ClientList.Remove(strTUserID);

                strLog = string.Format("  Ǿϴ."); //"[" + strClientID + "]" + "   ϼ̽ϴ.!!";
                Send_Msg(strLog);

                this.Invoke(new MethodInvoker(delegate()
                     {
                         for (int i = 0; i < lstIP.Items.Count; i++)
                         {
                             if (lstIP.Items[i].Text == strTUserID)
                             {
                                 lstIP.Items[i].Remove();
                             }
                         }

                         lstIP.Items.Clear();

                         ICollection keyColl = ClientList.Keys;
                         foreach (string s in keyColl)
                         {
                             Add_User(s);
                         }

                         Update_Client();
                     }));
            }
        }
    }
}
