﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Net;
using System.Net.Sockets;


namespace HPi_DM
{
    class EY_ClientSocket
    {
        DMClient DM_Client = null;
        private Socket EY_ChatClient = null;
        private string strHostName = "";
        private string strServerIP = "";
        private string strSocketErr = "";
        private string strReceiveMsg = "";
        private string strSendMsg = "";
        private int intServerPort = 0;
        private int intSize = 0;
        public bool bConnectServer = false;

        private byte[] byteReceiveMsg = new byte[1024];

        public EY_ClientSocket(DMClient DM_PClient)
        {
            IPHostEntry hostInfo = Dns.GetHostEntry(strHostName);
            IPAddress ipAddr = Dns.GetHostEntry(strHostName).AddressList[0];
            strServerIP = ipAddr.ToString();
            intServerPort = 3000;
            DM_Client = DM_PClient;
        }

        public string Get_MyIP()
        {
            return strServerIP;
        }

        public int Get_ServerPort()
        {
            return intServerPort;
        }

        public void Set_ServerIP(string strPServerIP)
        {
            strServerIP = strPServerIP;
        }

        public void Set_ServerPort(int intPServerPort)
        {
            intServerPort = intPServerPort;
        }

        public string Get_LastError()
        {
            return strSocketErr;
        }

        public bool Connect_Server(string strPID)
        {
            EY_ChatClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
            IPAddress ipServer = IPAddress.Parse(strServerIP);
            try
            {
                EY_ChatClient.Connect(new IPEndPoint(ipServer, intServerPort));
                bConnectServer = true;

                SendMsg(strPID);
                EY_ChatClient.BeginReceive(byteReceiveMsg, 0, byteReceiveMsg.Length, SocketFlags.None, new AsyncCallback(CallBack_ReceiveMsg), byteReceiveMsg);
            }
            catch (Exception err)
            {
                strSocketErr = err.Message;
                bConnectServer = false;
            }

            return bConnectServer;
        }

        public void SendMsg(string strPMsg)
        {
            byte[] byteSendMsg = new byte[1024];
            byteSendMsg = Encoding.Default.GetBytes(strPMsg);

            EY_ChatClient.BeginSend(byteSendMsg, 0, byteSendMsg.Length, SocketFlags.None, new AsyncCallback(CallBack_SendMsg), byteSendMsg);
        }

        private void CallBack_SendMsg(IAsyncResult ar)
        {
            byte[] bytes = (byte[])ar.AsyncState;

            try
            {
                intSize = EY_ChatClient.EndSend(ar);
                if (intSize == 0)
                {
                    Disconnect();
                }
                else
                {
                    strSendMsg = Encoding.Default.GetString(bytes, 0, intSize);
                    DM_Client.Add_Log(strSendMsg);
                    EY_ChatClient.BeginReceive(byteReceiveMsg, 0, byteReceiveMsg.Length, SocketFlags.None, new AsyncCallback(CallBack_ReceiveMsg), byteReceiveMsg);
                }
            }
            catch (Exception err)
            {
                strSocketErr = string.Format("{0}", err.Message);
                Disconnect();
            }
        }

        private void CallBack_ReceiveMsg(IAsyncResult ar)
        {
            byte[] bytes = (byte[])ar.AsyncState;
            try
            {
                intSize = EY_ChatClient.EndReceive(ar);
                strReceiveMsg = Encoding.Default.GetString(bytes, 0, intSize);

                DM_Client.ReceiveMsg_FromSocket(strReceiveMsg);
                EY_ChatClient.BeginReceive(byteReceiveMsg, 0, byteReceiveMsg.Length, SocketFlags.None, new AsyncCallback(CallBack_ReceiveMsg), byteReceiveMsg);
            }
            catch (Exception err)
            {
                strSocketErr = string.Format("{0}", err.Message);
                Disconnect();
            }
        }

        public void Disconnect()
        {
            if (EY_ChatClient != null)
            {
                EY_ChatClient.Close();
                EY_ChatClient = null;
                bConnectServer = false;
            }
            //DM_Client.Server_Disconnect();
        }
    }
}
