using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Collections;


namespace MTS
{

    class EY_ChildSocket
    {
        private Socket ClientSocket = null;
        private string strClientID = "";
        private string strReceiveMsg = "";
        private string strLog = "";
        private MTS MtsMsgServer = null;


        public EY_ChildSocket(Socket soc, string strID, MTS MtsServer)
        {
            ClientSocket = soc;
            MtsMsgServer = MtsServer;
            strClientID = strID;
            Receive();
        }

        private void Receive()
        {
            byte[] buff = new byte[4096];
            ClientSocket.BeginReceive(buff, 0, 4096, SocketFlags.None, new AsyncCallback(ReceiveCallBack), buff);
        }


        private void ReceiveCallBack(IAsyncResult ar)
        {
            try
            {
                byte[] Ibuff = (byte[])ar.AsyncState;
                int recv = ClientSocket.EndReceive(ar);

                if (recv == 0)
                {
                    Disconnect();
                    return;
                }
                else
                {
                    strReceiveMsg = Encoding.Default.GetString(Ibuff, 0, recv);
                    strLog = string.Format("[{0}] {1}", strClientID, strReceiveMsg);
                    MtsMsgServer.ReceiveMsg(strLog);
                    MtsMsgServer.Add_Log(strLog);
                    Receive();
                }
            }
            catch (Exception e)
            {
                // eyChatServer.Add_Log(e.Message);
                Console.WriteLine("{0}", e.Message);
                Disconnect();
            }
        }

        public void ClientSend(string msg)
        {
            try
            {
                byte[] Ibuff = Encoding.Default.GetBytes(msg);
                ClientSocket.BeginSend(Ibuff, 0, Ibuff.Length, SocketFlags.None, new AsyncCallback(SendCallBack), Ibuff);
            }
            catch
            {
                Disconnect();
            }
        }

        private void SendCallBack(IAsyncResult ar)
        {
            try
            {
                int send = ClientSocket.EndSend(ar);
                if (send == 0)
                {
                    Disconnect();
                }
                else
                {
                    Receive();
                }
            }
            catch
            {
                Disconnect();
            }
        }

        private void Disconnect()
        {
            if (ClientSocket != null)
            {
                ClientSocket.Close();
                ClientSocket = null;
            }

            MtsMsgServer.Remove_User(this.strClientID);
        }

    }//end of class
}//end of namespace
