﻿using System;
using System.Net;
using System.Threading;
using System.Collections;
using System.Net.Sockets;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MTS
{
    public partial class MTS : Form
    {
        private Thread ServerThread = null;
        private Socket ServerSocket = null;
        private bool bSocketEnd = false;
        private int intPortNum = 3000;
        private string strHostName = "";
        public string strVersion = "0.01";
        private string strLog = "";
        private string strErr = "";
        private string strCurTime = "";
        private string strClientID = "";
        private int intCurListPos = 0;
        public Hashtable ClientList = new Hashtable();

        public MTS()
        {
            InitializeComponent();
        }

        private void MTS_Load(object sender, EventArgs e)
        {
            this.Text = "ETRI MTS 테스트서버 - Version " + strVersion;
            txtWrite.Focus();
            lstLog.Items.Clear();

            if (ServerSocket != null)
            {
                strErr = string.Format("[서버] : 현재 서버 가동중입니다.!!");
                Add_Log(strErr);
                return;
            }
            ServerThread = new Thread(new ThreadStart(Thread_Run));
            ServerThread.IsBackground = true;
            ServerThread.Start();
            lblServerState.Text = "가동중";

            Update_ServerInfo();
        }

        private void startOnServerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (ServerSocket != null)
            {
                strErr = string.Format("[서버] : 현재 서버 가동중입니다.!!");
                Add_Log(strErr);
                return;
            }
        }
        
        /// <summary>
        /// 보내기 버튼을 눌렀을 때 처리되는 내용
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSend_Click(object sender, EventArgs e)
        {
            if (ClientList.Count == 0)
            {
                strErr = string.Format("[SYSTEM] : 연결된 클라이언트가 없습니다.");
                Add_Log(strErr);
                txtWrite.Text = "";
                txtWrite.Focus();
                return;
            }

            if (txtWrite.Text == "") return;

            if (lstIP.Items.Count < 1) return;

            string strCurUserID = "";
            strCurUserID = lstIP.Items[intCurListPos].SubItems[1].Text;

            strLog = string.Format("[서버] : {0}", txtWrite.Text);
            Add_Log(strLog);

            SendMsg(strCurUserID, txtWrite.Text);
            txtWrite.Text = "";
            txtWrite.Focus();
        }

        private void btnClose_Click_1(object sender, EventArgs e)
        {
            //창닫기
            Application.ExitThread();
        }

        private void btnNowTime_Click(object sender, EventArgs e)
        {
            //현재시간을 출력합니다.
            lblSelftime.Text = DateTime.Now.ToString();

            //또는 현재 아이피를 출력하고자 하는 경우
            //IPHostEntry localHostEntry = Dns.GetHostByName(Dns.GetHostName());
            //// 현재 컴퓨터의 아이피를 기본 아이피로 설정 
            //IP = localHostEntry.AddressList[0].ToString();
            //// 아이피 상자에 보여줍니다.
            //lblselfip.Text = "현재 서버IP는 : " + IP + " 입니다.";
        }

        private void txtWrite_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (int)Keys.Enter)
            {
                btnSend_Click(null, null);    
            }
        }


        public void Thread_Run()
        {
            ServerSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.IP);
            ServerSocket.Bind(new IPEndPoint(IPAddress.Any, intPortNum));
            ServerSocket.Listen(3);

            IPAddress ipAddr = Dns.GetHostEntry(strHostName).AddressList[0];
            IPHostEntry host = Dns.GetHostEntry("localhost");

            strLog = string.Format("[서버] : Computer Name - {0} ", host.HostName);
            Add_Log(strLog);
            strLog = string.Format("[서버] : IP Addr - {0}, Port Num - {1}", ipAddr, intPortNum);
            Add_Log(strLog);
            strLog = string.Format("[서버] : 서버 시작되었습니다.");
            Add_Log(strLog);

            while (bSocketEnd == false)
            {
                try
                {
                    Socket socClient = (Socket)ServerSocket.Accept();
                    ClientMessage_Process(socClient);
                }
                catch { }
            }
        }

        public void ClientMessage_Process(Socket socTClient)
        {
            byte[] buff = new Byte[512];
            socTClient.Receive(buff, 0, 512, SocketFlags.None);
            buff.Initialize();
            string strReceiveLogin = Encoding.Default.GetString(buff);
            strReceiveLogin = strReceiveLogin.TrimEnd('\0');

            if (ClientList.ContainsKey(strReceiveLogin))
            {
                buff = Encoding.Default.GetBytes("ER0001");
                socTClient.Send(buff, 0, buff.Length, SocketFlags.None);
                socTClient.Close();

                strLog = string.Format("[시스템] : {0}", "현재 접속중인 사용자의 아이디로 다른사람이 ");
                Add_Log(strLog);
                strLog = string.Format("[시스템] : {0}", "접근을 시도하였으나 종료시켰습니다.^^");
                Add_Log(strLog);
            }
            else
            {
                strClientID = strReceiveLogin;
                EY_ChildSocket eyChild = new EY_ChildSocket(socTClient, strClientID, this);
                ClientList.Add(strClientID, eyChild);
                Add_User(strClientID);

                strLog = "[" + strClientID + "]" + "님이 접속 하셨습니다.!!";
                SendMsgAll(strLog);
            }
        }


        public void Add_User(string strTUserID)
        {
            this.Invoke(new MethodInvoker(
                 delegate()
                 {
                     string[] strData = new string[2];
                     int intTClientCount = lstIP.Items.Count + 1;
                     strData[0] = intTClientCount.ToString();
                     strData[1] = strTUserID;
                     lstIP.Items.Add(new ListViewItem(strData));
                     Update_ServerInfo();
                 }
                 )
            );
        }


        public void Add_Log(string strTLog)
        {
            this.Invoke(new MethodInvoker(
                 delegate()
                 {
                     strCurTime = string.Format("{0:D2}:{1:D2}:{2:D2}", DateTime.Now.Hour, DateTime.Now.Minute, DateTime.Now.Second);
                     string[] strData = new string[3];
                     strData[0] = lstLog.Items.Count.ToString();
                     strData[1] = strCurTime;
                     strData[2] = strTLog;
                     lstLog.Items.Add(new ListViewItem(strData));
                 }
                 )
            );
        }

        private void Update_ServerInfo()
        {
            IPAddress ipAddr = Dns.GetHostEntry(strHostName).AddressList[0];
            lblServerIP.Text = ipAddr.ToString();
            lblServerPort.Text = intPortNum.ToString();
            lblClient.Text = ClientList.Count.ToString();
        }

        public void Remove_User(string strTUserID)
        {
            if (ClientList.ContainsKey(strTUserID))
            {
                ClientList.Remove(strTUserID);

                strLog = "[" + strClientID + "]" + "님이 접속 종료 하셨습니다.!!";
                SendMsgAll(strLog);

                this.Invoke(new MethodInvoker(delegate()
                     {
                         for (int i = 0; i < lstIP.Items.Count; i++)
                         {
                             if (lstIP.Items[i].Text == strTUserID)
                             {
                                 lstIP.Items[i].Remove();
                             }
                         }

                         lstIP.Items.Clear();

                         ICollection keyColl = ClientList.Keys;
                         foreach (string s in keyColl)
                         {
                             Add_User(s);
                         }

                         Update_ServerInfo();
                    }));
            }
        }

        private void lstIP_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lstIP.SelectedItems.Count > 0)
            {
                intCurListPos = lstIP.SelectedItems[0].Index;
            }
        }

        public void SendMsg(string id, string msg) //메시지를 보낸다.
        {
            if (ClientList.ContainsKey(id))
            {
                ((EY_ChildSocket)ClientList[id]).ClientSend(msg);
            }
        }

        private void SendMsgAll(string strMsg)
        {
            if (ClientList.Count == 0)
            {
                strErr = string.Format("[SYSTEM] : 연결된 클라이언트가 없습니다.");
                Add_Log(strErr);
                return;
            }

            ICollection keyColl = ClientList.Keys;
            foreach (string s in keyColl)
            {
                SendMsg(s, strMsg);
            }

            strLog = string.Format("[서버] : {0}", strMsg);
            Add_Log(strLog);
        }

        public void ReceiveMsg(string strReceiveMsg)
        {
            SendMsgAll(strReceiveMsg);
        }
    }//end of Class
}//End of Namespace